#include <ESP8266WiFi.h>            
#include <ESP8266WebServer.h>

int r = 0;
int g = 0;
int b = 0;
int w = 0;
int h = 1023;
const int rood = 5; // D1
const int groen = 4; // D2
const int blauw = 0; // D3
const int wit = 14; // D5
const int ingebouwde_led = 2; // D4 
const char* ssid = "SSID";
const char* password = "WACHTWOORD";

ESP8266WebServer server(80); // Webserver-object, luistert naar poort 80 (standaard voor HTTP).

// Configureer indien gewenst een vast ip-adres. Pas deze gegevens aan je thuisnetwerk aan.
// IPAddress ip(192, 168, 0, 121); 
// IPAddress gateway(192, 168, 0, 1);
// IPAddress subnet(255, 255, 255, 0);

void setup() {
  Serial.begin(115200);
  pinMode(rood, OUTPUT);
  pinMode(groen, OUTPUT);
  pinMode(blauw, OUTPUT);
  pinMode(wit, OUTPUT);
  pinMode(ingebouwde_led, OUTPUT);
  digitalWrite(rood, LOW);
  digitalWrite(groen, LOW);
  digitalWrite(blauw, LOW);
  digitalWrite(wit, LOW);
  digitalWrite(ingebouwde_led, LOW); // Led aan.

  // Verbind met WiFi-netwerk
  WiFi.mode(WIFI_STA); // De ESP is geen AP
  Serial.println();
  Serial.println();
  Serial.print("Verbind met ");
  Serial.println(ssid);
  // Gebruik de regel hieronder als je de module een vast ip-adres wilt geven.
  // WiFi.config(ip, gateway, subnet); 
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  digitalWrite(ingebouwde_led, HIGH); //Led uit.
  Serial.println("");
  Serial.println("WiFi verbonden");
  Serial.print("IP-adres: ");
  Serial.println(WiFi.localIP());
  server.on("/", handleArgs); // Stel het pad in.
  server.begin(); // Start de server
  Serial.println("Server listening");   
}

void handleArgs() { 
  String message = "<!DOCTYPE html><html><head>";
  message += "<meta name='viewport' content='height=device-height, width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no'><title>Ledstrip</title>";
  message += "<meta http-equiv='Cache-Control' content='no-cache, no-store, must-revalidate' /><meta http-equiv='Pragma' content='no-cache' /><meta http-equiv='Expires' content='0' />";
  message += "<style>body{background-color:rgb(0,0,0);text-align:center;white-space:nowrap;overflow:hidden;position:fixed;top:0px;left:0px;right:0px;bottom:0px;font-size:1.1em;}fieldset{border:none;}input{width:50%;max-width:400px;vertical-align:middle;}output{display:inline-block;min-width:2em;}label{display:inline-block;min-width:1em;}body,label,output{padding:2px 9px;border-radius:3px;font-family:sans-serif;color:#000;font-size:1.1em;}label[for=r],output[for=r]{background-color:#f00;}label[for=g],output[for=g]{background-color:#0f0;}label[for=b],output[for=b]{background-color:#00f;color:#fff;}label[for=w], output[for=w]{background-color:#fff;color:#000;}label[for=h],output[for=h]{background-color:#888;color:#fff;}input[type='range']::-webkit-slider-thumb{width:25px;height:25px;}</style>";
  message += "</head><body onload='setSliders();vCenter();' onresize='vCenter();'>";
  message += "<iframe name='query' id='query' style='width: 1px; height: 1px; visibility: hidden;'></iframe>";
  message += "<div id='vstretcher'></div>";
  message += "<div id='schuifjes'>";
  if (server.arg("r")== "" || server.arg("g")== "" || server.arg("b")== "" || server.arg("w")== "" || server.arg("h")== "") { // Ontbrekende parameters.
    message += "<form id='myForm' method='get' action='/' target='query'>";
    message += "<fieldset for='r'><label for='r'>R</label><input name='r' id='r' type='range' min='0' max='1023' step='1' value='";
    message += r;
    message += "' onchange='verstuur();'><output for='r' id='r_out'></output></fieldset>";
    message += "<fieldset for='g'><label for='g'>G</label><input name='g' id='g' type='range' min='0' max='1023' step='1' value='";
    message += g;
    message += "' onchange='verstuur();'><output for='g' id='g_out'></output></fieldset>";
    message += "<fieldset for='b'><label for='b'>B</label><input name='b' id='b' type='range' min='0' max='1023' step='1' value='";
    message += b;
    message += "' onchange='verstuur();'><output for='b' id='b_out'></output></fieldset>";
    message += "<fieldset for='w'><label for='w'>W</label><input name='w' id='w' type='range' min='0' max='1023' step='1' value='";
    message += w;
    message += "' onchange='verstuur();'><output for='w' id='w_out'></output></fieldset>";
    message += "<fieldset for='h'><label for='h'>&#9788;</label><input name='h' id='h' type='range' min='0' max='1023' step='1' value='";
    message += h;
    message += "' onchange='verstuur();'><output for='h' id='h_out'></output></fieldset>";
    message += "</form></div>";
    message += "<script>function verstuur(){document.getElementById('myForm').submit();}document.addEventListener('visibilitychange',function(){if (window.self == window.top){top.location.href='/';}});var body=document.body,r=document.querySelector('#r'),g=document.querySelector('#g'),b=document.querySelector('#b'),w=document.querySelector('#w'),h=document.querySelector('#h'),r_out=document.querySelector('#r_out'),g_out=document.querySelector('#g_out'),b_out=document.querySelector('#b_out'),w_out=document.querySelector('#w_out'),h_out=document.querySelector('#h_out');function setSliders(){r_out.value=Math.floor(r.value / 4);g_out.value=Math.floor(g.value / 4);b_out.value=Math.floor(b.value / 4);w_out.value=Math.floor(w.value / 4);h_out.value=Math.floor(h.value / 4);}r.addEventListener('input',function(){r_out.value=Math.floor(r.value / 4);},false);g.addEventListener('input',function(){g_out.value=Math.floor(g.value / 4);},false);b.addEventListener('input',function(){b_out.value=Math.floor(b.value / 4);},false);w.addEventListener('input',function(){w_out.value=Math.floor(w.value / 4);},false);h.addEventListener('input',function(){h_out.value=Math.floor(h.value / 4);},false);function vCenter(){var mainheight=document.getElementById('schuifjes').clientHeight;var winmargin=((window.innerHeight - mainheight) / 3);document.getElementById('vstretcher').style.height=winmargin+'px';}</script>";
    message += "</body></html>";
  }
  else { // Parameters aanwezig.
    message += "<form id='myForm' method='get' action='/' target='query'>";
    message += "<fieldset for='r'><label for='r'>R</label><input name='r' id='r' type='range' min='0' max='1023' step='1' value='";
    message += server.arg("r");
    message += "' onchange='verstuur();'><output for='r' id='r_out'></output></fieldset>";
    message += "<fieldset for='g'><label for='g'>G</label><input name='g' id='g' type='range' min='0' max='1023' step='1' value='";
    message += server.arg("g");
    message += "' onchange='verstuur();'><output for='g' id='g_out'></output></fieldset>";
    message += "<fieldset for='b'><label for='b'>B</label><input name='b' id='b' type='range' min='0' max='1023' step='1' value='";
    message += server.arg("b");
    message += "' onchange='verstuur();'><output for='b' id='b_out'></output></fieldset>";
    message += "<fieldset for='w'><label for='w'>W</label><input name='w' id='w' type='range' min='0' max='1023' step='1' value='";
    message += server.arg("w");
    message += "' onchange='verstuur();'><output for='w' id='w_out'></output></fieldset>";
    message += "<fieldset for='h'><label for='h'>&#9788;</label><input name='h' id='h' type='range' min='0' max='1023' step='1' value='";
    message += server.arg("h");
    message += "' onchange='verstuur();'><output for='h' id='h_out'></output></fieldset>";
    message += "</form></div>";
    message += "<script>function verstuur(){document.getElementById('myForm').submit();}document.addEventListener('visibilitychange',function(){if (window.self == window.top){top.location.href='/';}});var body=document.body,r=document.querySelector('#r'),g=document.querySelector('#g'),b=document.querySelector('#b'),w=document.querySelector('#w'),h=document.querySelector('#h'),r_out=document.querySelector('#r_out'),g_out=document.querySelector('#g_out'),b_out=document.querySelector('#b_out'),w_out=document.querySelector('#w_out'),h_out=document.querySelector('#h_out');function setSliders(){r_out.value=Math.floor(r.value / 4);g_out.value=Math.floor(g.value / 4);b_out.value=Math.floor(b.value / 4);w_out.value=Math.floor(w.value / 4);h_out.value=Math.floor(h.value / 4);}r.addEventListener('input',function(){r_out.value=Math.floor(r.value / 4);},false);g.addEventListener('input',function(){g_out.value=Math.floor(g.value / 4);},false);b.addEventListener('input',function(){b_out.value=Math.floor(b.value / 4);},false);w.addEventListener('input',function(){w_out.value=Math.floor(w.value / 4);},false);h.addEventListener('input',function(){h_out.value=Math.floor(h.value / 4);},false);function vCenter(){var mainheight=document.getElementById('schuifjes').clientHeight;var winmargin=((window.innerHeight - mainheight) / 3);document.getElementById('vstretcher').style.height=winmargin+'px';}</script>";
    message += "</body></html>";
    r = server.arg("r").toInt();
    g = server.arg("g").toInt();
    b = server.arg("b").toInt();
    w = server.arg("w").toInt();
    h = server.arg("h").toInt();
    float helderheid = server.arg("h").toFloat() / 1023;
    Serial.print("helderheid = ");
    Serial.println(helderheid);
    int roodwaarde = r * helderheid;
    Serial.print("rood = ");
    Serial.println(roodwaarde);
    int groenwaarde = g * helderheid;
    Serial.print("groen = ");
    Serial.println(groenwaarde);
    int blauwwaarde = b * helderheid;
    Serial.print("blauw = ");
    Serial.println(blauwwaarde);
    int witwaarde = w * helderheid;
    Serial.print("wit = ");
    Serial.println(witwaarde);
    analogWrite(rood, roodwaarde);
    analogWrite(groen, groenwaarde);
    analogWrite(blauw, blauwwaarde);
    analogWrite(wit, witwaarde);
  }
  server.send(200, "text/html", message); // Geeft de HTTP respons.
}

void loop() {
  server.handleClient(); // Afhandeling van inkomende verzoeken.
}
